// C Source File
// Created 6/13/2002; 8:08:22 PM

#define USE_TI89              // Produce .89z File

#define OPTIMIZE_ROM_CALLS    // Use ROM Call Optimization

#define SAVE_SCREEN           // Save/Restore LCD Contents

#include <tigcclib.h>         // Include All Header Files

#define ARROW_ROW	0xFFFE

//global variables
int highs1=0;
int highs2=0;
int speed=5;
int lines=5;
int gamemode=1;
//global variables

void delay(void) {
	short int loop = speed*20+75, randNum;
	
	// generate random numbers to slow down the program...
	while (loop-- > 0) {
		randNum = rand() % loop;
	}
}

void drawShip(int x){
	DrawPix(x,99,A_XOR);
	DrawPix(x+1,98,A_XOR);
	DrawPix(x+2,99,A_XOR);
}

void gameloop(void){
	int gloop;
	int x;
	int key,a;
	int score;
	int linex[12];
	int liney;
	for (a=0;a<12;a++){
		linex[a]=-99;
	}
	liney=-99;
	gloop=1;x=79;
	score=0;
	ClrScr();
	drawShip(x);
	INT_HANDLER interrupt1 = GetIntVec(AUTO_INT_1);
	SetIntVec(AUTO_INT_1,DUMMY_HANDLER);
	while (gloop){
		key=_rowread(ARROW_ROW);
		if (key&0x0002&&x>0){//left
			if (!GetPix(x-1,99)){
				drawShip(x);
				x--;
				drawShip(x);
			}
		}
		if (key&0x0008&&x<157){//right
			if (!GetPix(x+3,99)){
				drawShip(x);
				x++;
				drawShip(x);
			}
		}
		if (liney==-99){
			liney=0;
			for (a=0;a<lines;a++){
				linex[a]=random(159);
			}
		}
		for (a=0;a<12;a++){
			if (linex[a]!=-99){
				if (gamemode==1){
					DrawPix(linex[a],liney,A_XOR);
				}
				if (gamemode==2){
					DrawPix(linex[a],liney,A_NORMAL);
				}
			}
		}
		if (liney==97||liney==98||liney==99){
			for (a=0;a<12;a++){
				if (x==linex[a]||x+1==linex[a]||x+2==linex[a]){
					gloop=0;
				}
			}
		}
		liney++;
		if (gamemode==1){
			if (liney==100){liney=-99;}
		}
		if (gamemode==2){
			if (liney==98){liney=-99;}
		}
		score++;
		if (_rowread(~((short)(1<<1))) & (1<<6)){//clear
			gloop=0;
		}
		delay();
	}
	SetIntVec(AUTO_INT_1,interrupt1);
	FontSetSys(F_8x10);
	printf_xy(30,40,"Score:  %d",score);
	if (gamemode==1){
		if (score>highs1){
			highs1=score;
		}
	}
	if (gamemode==2){
		if (score>highs2){
			highs2=score;
		}
	}
	if (kbhit()){
		ngetchx();
	}
	ngetchx();
	return;
}

void resethi(void){
	int rloop;
	int key;
	rloop=1;
	ClrScr();
	FontSetSys(F_8x10);
	DrawStr(0,0,"Reset Highscores?",A_NORMAL);
	DrawStr(0,10,"Yes=F5",A_NORMAL);
	DrawStr(0,20,"No=ENTER",A_NORMAL);
	while (rloop){
		key=ngetchx();
		if (key==KEY_F5){
			highs1=0;highs2=0;
			ClrScr();
			DrawStr(0,0,"High Scores Reset!",A_NORMAL);
			ngetchx();
			rloop=0;
		}
		if (key==KEY_ENTER){
			rloop=0;
		}
	}
	return;
}

void optionscreen(void){
	int oloop;
	int sel;
	int key,a;
	int reshi=0;
	oloop=1;
	sel=1;
	ClrScr();
	FontSetSys(F_8x10);
	DrawStr(0,0,"Options",A_NORMAL);
	FontSetSys(F_6x8);
	DrawStr(0,10,"Speed:          ",A_REVERSE);
	DrawStr(0,18,"Lines at a time:",A_NORMAL);
	DrawStr(0,26,"Game play mode:",A_NORMAL);
	DrawStr(0,34,"Reset Highscores",A_NORMAL);
	printf_xy(100,10,"%d",speed);
	printf_xy(100,18,"%d",lines);
	printf_xy(100,26,"%d",gamemode);
	while (oloop){
		key=ngetchx();
		for (a=sel*8+2;a<=sel*8+9;a++){
			DrawLine(0,a,95,a,A_XOR);
		}
		if (key==KEY_DOWN){
			sel++;
			if (sel==5){
				sel=1;
			}
		}
		if (key==KEY_UP){
			sel--;
			if (sel==0){
				sel=4;
			}
		}
		if (key==KEY_ESC||key==KEY_CLEAR){
			oloop=0;
		}
		for (a=sel*8+2;a<=sel*8+9;a++){
			DrawLine(0,a,95,a,A_XOR);
		}
		if (key==KEY_LEFT){
			if (sel==1){
				if (speed){
					speed--;
				}
				printf_xy(100,10,"%d ",speed);
			}
			if (sel==2){
				if (lines>3){
					lines--;
				}
				printf_xy(100,18,"%d ",lines);
			}
			if (sel==3){
				gamemode=1;
				DrawStr(100,26,"1",A_REPLACE);
			}
		}
		if (key==KEY_RIGHT){
			if (sel==1){
				if (speed<51){
					speed++;
				}
				printf_xy(100,10,"%d ",speed);
			}
			if (sel==2){
				if (lines<12){
					lines++;
				}
				printf_xy(100,18,"%d ",lines);
			}
			if (sel==3){
				gamemode=2;
				DrawStr(100,26,"2",A_REPLACE);
			}
		}
		if (key==KEY_ENTER&&sel==4){
			oloop=0;reshi=1;
		}
	}
	if (reshi){
		reshi=0;
		resethi();
		optionscreen();
	}
	return;
}

void menuloop(void){
	int mloop=1;
	int sel=1;
	int key,a;
	int remake=0;
	int optn=0;
	int gm=0;
	ClrScr();
	mloop=1;sel=1;
	FontSetSys(F_8x10);
	DrawStr(0,0,"PrgmBAD",A_NORMAL);
	FontSetSys(F_6x8);
	DrawStr(0,10,"New Game",A_REVERSE);
	DrawStr(0,18,"Options",A_NORMAL);
	DrawStr(0,26,"About",A_NORMAL);
	DrawStr(0,34,"Quit",A_NORMAL);
	FontSetSys(F_8x10);
	DrawStr(0,42,"High Score #1:",A_NORMAL);
	printf_xy(75,52,"%d",highs1);
	DrawStr(0,62,"High Score #2:",A_NORMAL);
	printf_xy(75,72,"%d",highs2);
	while (mloop){
		key=ngetchx();
		for (a=sel*8+2;a<=sel*8+9;a++){
			DrawLine(0,a,47,a,A_XOR);
		}
		if (key==KEY_DOWN){
			sel++;
			if (sel==5){
				sel=1;
			}
		}
		if (key==KEY_UP){
			sel--;
			if (sel==0){
				sel=4;
			}
		}
		if (key==KEY_ESC||key==KEY_CLEAR){
			mloop=0;
		}
		for (a=sel*8+2;a<=sel*8+9;a++){
			DrawLine(0,a,47,a,A_XOR);
		}
		if (key==KEY_ENTER){
			if (sel==1){
				mloop=0;gm=1;
			}
			if (sel==2){
				mloop=0;optn=1;
			}
			if (sel==3){
				clrscr();
				FontSetSys(F_8x10);
				printf("Programmed by:     Chickendude\nSpecial Thanks to: Josh Lichti & TommyS.\nPorted By:\nPhil Software");
				ngetchx();
				mloop=0;remake=1;
			}
			if (sel==4){
				exit(0);
			}
		}
	}
	if (remake){
		remake=0;
		menuloop();
	}
	if (optn){
		optn=0;
		optionscreen();
		menuloop();
	}
	if (gm){
		gm=0;
		gameloop();
		menuloop();
	}
	return;
}

// Main Function
void _main(void)
{
	randomize();
	menuloop();
}
